<?php

interface SGIDatabaseAdapter
{
	/*
		The query may contain any of the following placeholders: %s, %d and %f
		The number of given parameters must be equal to the number of placeholders.
		This method must return the fetched results if the query is fetchable.
	*/
	public function query($query, $params=array());

	/*
		Execute a query and return the statement object.
	*/
	public function exec($query, $params=array());

	/*
		Fetch a row from a previously executed query.
	*/
	public function fetch($st);

	/*
		Return the last insert id.
	*/
	public function lastInsertId();

	/*
		Print the error (if any) generated by the most recent query.
	*/
	public function printLastError();

	/*
		Execute query depending on whether mysqli is available or not
	*/
	public function execWithAdapter($query, $driver, $params=array());

	/*
		Connecto to database over mysqli
	*/
    public function connectOverMySqli();

	/*
		Close mysqli connection
	*/
    public function closeMySqliConnection();

	/*
		Check if mysqli is available
	*/
    public function isMySqliAvailable();

    public function flush();
}
